// ResizeBarBis.cpp: implementation of the CJeremyBitmapResizeBar class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MakeTerrain.h"
#include "JeremyBitmapResizeBar.h"
#include "afxpriv.h"
#include "winuser.h"
#include "windows.h"



#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif




//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_DYNAMIC(CJeremyBitmapResizeBar, CDialogBar)

BEGIN_MESSAGE_MAP(CJeremyBitmapResizeBar, CDialogBar)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_WINDOWPOSCHANGING()


	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CJeremyBitmapResizeBar::CJeremyBitmapResizeBar()
{
	CY = 150;
	CX = 150;

	FlotSize.cx = 200;
	FlotSize.cy = 200;
	m_sizeDefault.cx = CX;
	m_sizeDefault.cy = CY;

	OnSplit = FALSE;
	bmp = NULL;

	DlgListe = NULL;

}


CJeremyBitmapResizeBar::~CJeremyBitmapResizeBar()
{

	if (bmp) DeleteObject (bmp);
}

void CJeremyBitmapResizeBar::OnWindowPosChanging(WINDOWPOS FAR* lpwndpos) 
{
	CDialogBar::OnWindowPosChanging(lpwndpos);
}


CSize CJeremyBitmapResizeBar :: CalcFixedLayout(BOOL bStretch, BOOL bHorz)
{

	if (bStretch) // if not docked stretch to fit
	{
		ResizeChild ();
		return CSize(bHorz ? 32767 : m_sizeDefault.cx,bHorz ? m_sizeDefault.cy : 32767);
	}
	else
	{
		ResizeChild ();
		return m_sizeDefault;
	}
}



CSize CJeremyBitmapResizeBar :: CalcDynamicLayout(int nLength, DWORD dwMode)
{
	// Quand nLength = 0 alors Floating
	if (nLength == 0)
	{
		if ((dwMode&LM_HORZ)&&(dwMode&LM_HORZDOCK))
			m_sizeDefault.cx = FlotSize.cx;

		if (dwMode&LM_VERTDOCK)
			m_sizeDefault.cy = FlotSize.cy;
	}

	// Redimensionnement en X et en Y
	if (dwMode == LM_HORZ)
	{
		m_sizeDefault.cx = nLength;
		FlotSize.cx = nLength;
	}

	if (dwMode & LM_LENGTHY)
	{
		m_sizeDefault.cy = nLength;
		FlotSize.cy = nLength;
	}


	if (nLength==-1)
	{
		// Docking  droite ou  gauche
		if ((dwMode & LM_VERTDOCK) && nLength==-1) 
		{
			CSize size = GetParentSize ();
			if (size.cy >= 0) m_sizeDefault.cy = size.cy+INC_SIZE_Y;
			m_sizeDefault.cx = CX;
		}

		// Docking en haut ou en bas
		if ((dwMode & LM_HORZDOCK) && nLength==-1) 
		{
			CSize size = GetParentSize ();
			if (size.cx >= 0) m_sizeDefault.cx = size.cx+INC_SIZE_X;
			m_sizeDefault.cy = CY;
		}
	}


	


	return m_sizeDefault;

}

void CJeremyBitmapResizeBar::OnSize(UINT nType, int cx, int cy) 
{
	CDialogBar::OnSize(nType, cx, cy);
	ResizeChild ();
}




BOOL CJeremyBitmapResizeBar :: OnEraseBkgnd(CDC * pDC)
{
	RECT rc;
	GetClientRect (&rc);
	CBrush hbr (GetSysColor (COLOR_3DFACE));
	pDC->FillRect (&rc,&hbr);
	return TRUE;
}

CSize CJeremyBitmapResizeBar:: SetFixedLayoutCx (CFrameWnd * pFrame,int cx)
{
	CSize size;
	if (!pFrame) pFrame = GetDockingFrame ();
	size = m_sizeDefault;
	CX += cx;
	if (CX < 15) CX = 15;
	pFrame->RecalcLayout ();
	InvalidateRect (NULL,TRUE);
	return size;
}

CSize CJeremyBitmapResizeBar:: SetFixedLayoutCy (CFrameWnd * pFrame,int cy)
{
	CSize size;
	if (!pFrame) pFrame = GetDockingFrame ();
	size = m_sizeDefault;
	CY += cy;
	if (CY < 15) CY = 15;
	pFrame->RecalcLayout ();
	InvalidateRect (NULL,TRUE);
	return size;
}





void CJeremyBitmapResizeBar::OnPaint() 
{
	PAINTSTRUCT ps;
	CDC * pDC;
	pDC = BeginPaint (&ps);
	Draw (pDC);
	EndPaint (&ps);

	CSize size = GetParentSize ();

	DWORD style;
	style = GetBarStyle ();
	if (style&CBRS_ALIGN_LEFT || style&CBRS_ALIGN_RIGHT)
	if (m_sizeDefault.cy < size.cy)
	{
		CFrameWnd * parent;
		parent = GetDockingFrame ();
		parent->RecalcLayout ();
	}

	if (style&CBRS_ALIGN_TOP || style&CBRS_ALIGN_BOTTOM)
	if (m_sizeDefault.cx < size.cx)
	{
		CFrameWnd * parent;
		parent = GetDockingFrame ();
		parent->RecalcLayout ();
	}
	
	ResizeChild ();
}

void CJeremyBitmapResizeBar :: Draw (CDC * pDC)
{
	RECT rc;
	
	// Prise des dimensions
	GetClientRect (&rc);
	
	// Dessiner la barre si on est dock
	if (!IsFloating ())
	{
		DWORD style;
		style = GetBarStyle();
		
		if (style&CBRS_ALIGN_LEFT)
		{
			rc.left = rc.right - SPLITSIZE;
			pDC->Draw3dRect (rc.left,rc.top,SPLITSIZE,rc.bottom,
			GetSysColor (COLOR_3DHILIGHT),
			GetSysColor (COLOR_3DSHADOW));
		}

		if (style&CBRS_ALIGN_RIGHT)
		{
			pDC->Draw3dRect (rc.left,rc.top,SPLITSIZE,rc.bottom,
				GetSysColor (COLOR_3DHILIGHT),
				RGB (0,0,0));
			
			pDC->Draw3dRect (rc.left+1,rc.top+1,SPLITSIZE-2,rc.bottom-2,
				RGB (255,255,255),
				GetSysColor (COLOR_3DSHADOW));
		}

		if (style&CBRS_ALIGN_TOP)
		{
			rc.top = rc.bottom - SPLITSIZE;
			pDC->Draw3dRect (rc.left,rc.top,rc.right,SPLITSIZE, 
			GetSysColor (COLOR_3DHILIGHT),
			GetSysColor (COLOR_3DSHADOW));
		}

		if (style&CBRS_ALIGN_BOTTOM)
		{
			pDC->Draw3dRect (rc.left,rc.top,rc.right,SPLITSIZE,
				GetSysColor (COLOR_3DHILIGHT),
				RGB (0,0,0));
			
			pDC->Draw3dRect (rc.left+1,rc.top+1,rc.right-2,SPLITSIZE-2,
				RGB (255,255,255),
				GetSysColor (COLOR_3DSHADOW));
		}

	}

	// Faire le contour
	// C'est mieu de le faire aprs tout.
	pDC->Draw3dRect(0,0,rc.right,rc.bottom,
		GetSysColor (COLOR_3DSHADOW),
		GetSysColor (COLOR_3DHILIGHT));

	pDC->Draw3dRect(1,1,rc.right-2,rc.bottom-2,
		GetSysColor (COLOR_3DHILIGHT),
		GetSysColor (COLOR_3DSHADOW));

}




void CJeremyBitmapResizeBar :: ResizeChild ()
{
	RECT rc;
	GetClientRect (&rc);
	DWORD style;
	int cxdep = 0;

	//if (DlgListe)	DlgListe->MoveWindow (10,10,rc.right-20,rc.bottom-20,TRUE);



	if (!DlgListe) return;
	// prise de pointeur sur la vue active
	GetClientRect(&rc);

	if (!IsFloating ())
	{
		
		style = GetBarStyle ();
		if (style & CBRS_ALIGN_LEFT)
			DlgListe->MoveWindow (0,15,rc.right-SPLITSIZE,rc.bottom-20,TRUE);

		if (style & CBRS_ALIGN_RIGHT)
			DlgListe->MoveWindow (SPLITSIZE,15,rc.right-SPLITSIZE,rc.bottom-20,TRUE);

		if (style & CBRS_ALIGN_TOP )
			DlgListe->MoveWindow (0,15,rc.right,rc.bottom-15-SPLITSIZE,TRUE);

		if (style & CBRS_ALIGN_BOTTOM)
			DlgListe->MoveWindow (0,15,rc.right,rc.bottom-15,TRUE);
	}
	else	DlgListe->MoveWindow (0,0,rc.right,rc.bottom,TRUE);
	
}


void CJeremyBitmapResizeBar::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	RECT rc;
	HCURSOR Cursor;
	
	if (!IsFloating ())
	{
		DWORD style;
		style = GetBarStyle();
		GetClientRect (&rc);
		
		if (style&CBRS_ALIGN_LEFT)
		if (point.x >= rc.right - SPLITSIZE && point.x <= rc.right)
		{
			Cursor = AfxGetApp()->LoadStandardCursor(IDC_SIZEWE);
			SetCursor (Cursor);
			style=CBRS_ALIGN_LEFT;
		}

		if (style&CBRS_ALIGN_RIGHT)
		if (point.x >=0 && point.x <= SPLITSIZE)
		{
			Cursor = AfxGetApp()->LoadStandardCursor(IDC_SIZEWE);
			SetCursor (Cursor);
			style=CBRS_ALIGN_RIGHT;
		}

		if (style&CBRS_ALIGN_TOP)
		if (point.y >= rc.bottom - SPLITSIZE && point.y <= rc.bottom)
		{
			Cursor = AfxGetApp()->LoadStandardCursor(IDC_SIZENS);
			SetCursor (Cursor);
			style=CBRS_ALIGN_TOP;
		}
	
		if (style&CBRS_ALIGN_BOTTOM)
		if (point.y >= 0 && point.y <= SPLITSIZE)
		{
			Cursor = AfxGetApp()->LoadStandardCursor(IDC_SIZENS);
			SetCursor (Cursor);
			style=CBRS_ALIGN_BOTTOM;
		}
	}
	

	if (OnSplit)
	{
		if (xsplit!=-1)	
		{
			DrawSplit (xsplitprev,-1,CBRS_ALIGN_LEFT);
			DrawSplit (point.x,-1,CBRS_ALIGN_LEFT);
		}
		if (ysplit!=-1)
		{
			DrawSplit (-1,ysplitprev,CBRS_ALIGN_TOP);
			DrawSplit (-1,point.y,CBRS_ALIGN_TOP);
		}
		xsplitprev = point.x;
		ysplitprev = point.y;


	}

		
	CDialogBar::OnMouseMove(nFlags, point);
}


void CJeremyBitmapResizeBar::OnLButtonDown(UINT nFlags, CPoint point) 
{
	
	RECT rc;
	DWORD style;
	// TODO: Add your message handler code here and/or call default
	if (!IsFloating ())
	{
		style = GetBarStyle();
		GetClientRect (&rc);
		
		if (style&CBRS_ALIGN_LEFT)
		if (point.x >= rc.right - SPLITSIZE && point.x <= rc.right)
		{
			xsplit = rc.right - SPLITSIZE;
			ysplit = -1;
			OnSplit = TRUE;
			styledep= CBRS_ALIGN_LEFT;
		}

		if (style&CBRS_ALIGN_RIGHT)
		if (point.x >=0 && point.x <= SPLITSIZE)
		{
			xsplit = 0;
			ysplit = -1;
			OnSplit = TRUE;
			styledep= CBRS_ALIGN_RIGHT;
		}

		if (style&CBRS_ALIGN_TOP)
		if (point.y >= rc.bottom - SPLITSIZE && point.y <= rc.bottom)
		{
			xsplit = -1;
			ysplit = rc.bottom-SPLITSIZE;
			OnSplit = TRUE;
			styledep= CBRS_ALIGN_TOP;
		}
	
		if (style&CBRS_ALIGN_BOTTOM)
		if (point.y >= 0 && point.y <= SPLITSIZE)
		{
			xsplit = -1;
			ysplit = 0;
			OnSplit = TRUE;
			styledep= CBRS_ALIGN_BOTTOM;
		}
	}
	if (OnSplit) 
	{
		SetCapture ();
		DrawSplit (xsplit,ysplit,styledep);
		xsplitprev = xsplit;
		ysplitprev = ysplit;
	}
	else
		CDialogBar :: OnLButtonDown (nFlags,point);
}

void CJeremyBitmapResizeBar::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (OnSplit) 
	{
		if (xsplit!=-1)	
		{
			DrawSplit (xsplitprev,-1,CBRS_ALIGN_LEFT);
			if (styledep == CBRS_ALIGN_LEFT)
			SetFixedLayoutCx (NULL,-(xsplit-point.x));
			else
			SetFixedLayoutCx (NULL,(xsplit-point.x));

		}

		if (ysplit!=-1)
		{
			DrawSplit (-1,ysplitprev,CBRS_ALIGN_TOP);
			if (styledep == CBRS_ALIGN_TOP)
			SetFixedLayoutCy (NULL,-(ysplit-point.y));
			else
			SetFixedLayoutCy (NULL,(ysplit-point.y));

		}

		OnSplit = FALSE;
		ReleaseCapture ();
	}
	else
	CDialogBar :: OnLButtonUp (nFlags,point);
}



void CJeremyBitmapResizeBar::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CDialogBar::OnLButtonDblClk(nFlags, point);
}



void CJeremyBitmapResizeBar :: DrawSplit (int x,int y,DWORD style)
{
	LOGBRUSH log;
	CDC * pDC;
	RECT rc;
	CWnd * wnd;
	POINT pt;
	CBrush hbr, * old;

	// On dessine le splitter sur la suface de travail
	// de l'application
	wnd = AfxGetMainWnd ();

	log.lbStyle		= BS_PATTERN8X8;
	log.lbHatch		= (LONG) bmp;
	hbr.CreateBrushIndirect (&log);

	GetClientRect (&rc);
	pDC = wnd->GetDC ();

	old = (CBrush *) pDC->SelectObject (&hbr);
	switch (style)
	{
	
		case CBRS_ALIGN_LEFT:
		case CBRS_ALIGN_RIGHT:
		pt.x = x;
		pt.y = 0;
		ClientToScreen (&pt);
		wnd->ScreenToClient (&pt);
		pDC->PatBlt (pt.x,pt.y,SPLITSIZE-1,rc.bottom,PATINVERT);
		break;

		case CBRS_ALIGN_TOP:
		case CBRS_ALIGN_BOTTOM:
		pt.x = 0;
		pt.y = y;
		ClientToScreen (&pt);
		wnd->ScreenToClient (&pt);
		pDC->PatBlt (pt.x,pt.y,rc.right,SPLITSIZE-1,PATINVERT);
		break;


	}
	pDC->SelectObject (old);
	wnd->ReleaseDC (pDC);
}



void CJeremyBitmapResizeBar::OnBarStyleChange(DWORD dwOldStyle, DWORD dwNewStyle)
{
}

CSize CJeremyBitmapResizeBar :: GetParentSize ()
{
	CWnd * parent;
	CSize size;
	RECT rc;
	parent = GetParent ();
	parent->GetClientRect (&rc);
	size.cx = rc.right;
	size.cy = rc.bottom;
	return size;
}



// Cette focntion permet d'initialiser une boite de dialogue
// de fond pour avoir des rgfrences sur des objet avec DoDatExchange.
BOOL CJeremyBitmapResizeBar :: ReplaceDialogue (CDialog * Dlg,UINT IDD_DIALOGUE)
{
	BOOL ret;
	ret = Dlg->Create (IDD_DIALOGUE,this);
	if (ret)
		Dlg->ShowWindow (SW_SHOW);
	DlgListe = Dlg;
	return ret;
}





